package logger

import (
	"os"
	"github.com/rs/zerolog"
	"time"
)

var LogDirPrefix string = "./.logs/"
var LogDir string
var LogFile *os.File

var log zerolog.Logger
var err error

func GetLogger(name string) zerolog.Logger {
	LogDir = LogDirPrefix + "/" + LogDir

	if err := os.MkdirAll(LogDir, 0755); err != nil {
		panic("cannot create log directory: " + LogDir + " (" + err.Error() + ")")
	}
	if LogFile, err = os.OpenFile(LogDir+time.Now().Format(time.RFC3339)+".log", os.O_RDWR|os.O_CREATE|os.O_APPEND, 0666); err != nil {
		panic("cannot create log file: " + err.Error())
	}
	multi := zerolog.MultiLevelWriter(zerolog.ConsoleWriter{Out: os.Stderr}, LogFile)
	return zerolog.New(multi).With().Timestamp().Str("Origin", name).Logger()
}
